Hex Artifact Content

Artifact 68229c87b4835b75d27dfa48a6883b930dedda2b:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50   verifyRequiredP
0570: 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63  ackages() {..loc
0580: 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e  al pkg pkgdomain
0590: 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63   pkgversion..loc
05a0: 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e  al pkgdir pkgcon
05b0: 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a  figdir pkgfound.
05c0: 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b  ..for pkg in "${
05d0: 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f  require[@]}"; do
05e0: 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a  ...pkgdomain=''.
05f0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a  ..pkgversion=''.
0600: 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 43 46  ..pkgchanges=(CF
0610: 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41 54  LAGS LDFLAGS PAT
0620: 48 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  H PKG_CONFIG_PAT
0630: 48 29 0a 0a 09 09 63 61 73 65 20 22 24 7b 70 6b  H)....case "${pk
0640: 67 7d 22 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09  g}" in....*:*)..
0650: 09 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 24  ...pkgchanges=($
0660: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0670: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 3a 27   cut -f 2 -d ':'
0680: 29 29 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63  )).....pkg="$(ec
0690: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
06a0: 74 20 2d 66 20 31 20 2d 64 20 27 3a 27 29 22 0a  t -f 1 -d ':')".
06b0: 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09  ....;;...esac...
06c0: 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22 20 69  .case "${pkg}" i
06d0: 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09  n....*/*@*).....
06e0: 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68  pkgdomain="$(ech
06f0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0700: 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22 0a 09   -f 2 -d '@')"..
0710: 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24  ...pkgversion="$
0720: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0730: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27   cut -f 2 -d '/'
0740: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
0750: 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  @')".....pkg="$(
0760: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0770: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
0780: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29  ".....;;....*/*)
0790: 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d  .....pkgversion=
07a0: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
07b0: 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27   | cut -f 2 -d '
07c0: 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  /')".....pkg="$(
07d0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
07e0: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
07f0: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29  ".....;;....*@*)
0800: 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22  .....pkgdomain="
0810: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0820: 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 40  | cut -f 2 -d '@
0830: 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65  ')".....pkg="$(e
0840: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0850: 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29 22  ut -f 1 -d '@')"
0860: 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a  .....;;...esac..
0870: 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67  ..if [ -z "${pkg
0880: 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e  domain}" ]; then
0890: 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24  ....pkgdomain="$
08a0: 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a  {domain}"...fi..
08b0: 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09  ..pkgfound='0'..
08c0: 09 66 6f 72 20 70 6b 67 64 69 72 20 69 6e 20 22  .for pkgdir in "
08d0: 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67  /opt/appfs/${pkg
08e0: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70  domain}/${pkg}/p
08f0: 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65  latform"/${pkgve
0900: 72 73 69 6f 6e 3a 2d 6c 61 74 65 73 74 7d 20 22  rsion:-latest} "
0910: 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67  /opt/appfs/${pkg
0920: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70  domain}/${pkg}/p
0930: 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65  latform"/${pkgve
0940: 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09  rsion:-*}; do...
0950: 09 70 6b 67 63 6f 6e 66 69 67 64 69 72 3d 22 24  .pkgconfigdir="$
0960: 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67  {pkgdir}/lib/pkg
0970: 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69 66 20 5b  config".....if [
0980: 20 21 20 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d   ! -d "${pkgdir}
0990: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f  " ]; then.....co
09a0: 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 0a 09 09  ntinue....fi....
09b0: 09 23 20 49 66 20 74 68 65 20 70 61 63 6b 61 67  .# If the packag
09c0: 65 20 76 65 72 73 69 6f 6e 20 77 61 73 20 75 6e  e version was un
09d0: 73 70 65 63 69 66 69 65 64 2c 20 66 75 6c 6c 79  specified, fully
09e0: 20 72 65 73 6f 6c 76 65 0a 09 09 09 23 20 74 68   resolve....# th
09f0: 65 20 64 69 72 65 63 74 6f 72 79 20 74 68 61 74  e directory that
0a00: 20 77 65 20 66 6f 75 6e 64 0a 09 09 09 69 66 20   we found....if 
0a10: 5b 20 2d 7a 20 22 24 7b 70 6b 67 76 65 72 73 69  [ -z "${pkgversi
0a20: 6f 6e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  on}" ]; then....
0a30: 09 70 6b 67 64 69 72 3d 22 24 28 72 65 61 64 6c  .pkgdir="$(readl
0a40: 69 6e 6b 20 2d 66 20 22 24 7b 70 6b 67 64 69 72  ink -f "${pkgdir
0a50: 7d 22 29 22 0a 09 09 09 66 69 0a 0a 09 09 09 70  }")"....fi.....p
0a60: 6b 67 66 6f 75 6e 64 3d 27 31 27 0a 0a 09 09 09  kgfound='1'.....
0a70: 66 6f 72 20 70 6b 67 63 68 61 6e 67 65 20 69 6e  for pkgchange in
0a80: 20 22 24 7b 70 6b 67 63 68 61 6e 67 65 73 5b 40   "${pkgchanges[@
0a90: 5d 7d 22 3b 20 64 6f 0a 09 09 09 09 63 61 73 65  ]}"; do.....case
0aa0: 20 22 24 7b 70 6b 67 63 68 61 6e 67 65 7d 22 20   "${pkgchange}" 
0ab0: 69 6e 0a 09 09 09 09 09 43 46 4c 41 47 53 29 0a  in......CFLAGS).
0ac0: 09 09 09 09 09 09 43 46 4c 41 47 53 3d 22 24 7b  ......CFLAGS="${
0ad0: 43 46 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67 64  CFLAGS} -I${pkgd
0ae0: 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 09  ir}/include"....
0af0: 09 09 09 43 50 50 46 4c 41 47 53 3d 22 24 7b 43  ...CPPFLAGS="${C
0b00: 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b 70 6b 67  PPFLAGS} -I${pkg
0b10: 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09  dir}/include"...
0b20: 09 09 09 09 65 78 70 6f 72 74 20 43 46 4c 41 47  ....export CFLAG
0b30: 53 20 43 50 50 46 4c 41 47 53 0a 09 09 09 09 09  S CPPFLAGS......
0b40: 09 3b 3b 0a 09 09 09 09 09 4c 44 46 4c 41 47 53  .;;......LDFLAGS
0b50: 29 0a 09 09 09 09 09 09 4c 44 46 4c 41 47 53 3d  ).......LDFLAGS=
0b60: 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d 4c 24 7b  "${LDFLAGS} -L${
0b70: 70 6b 67 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c  pkgdir}/lib -Wl,
0b80: 2d 72 70 61 74 68 2c 24 7b 70 6b 67 64 69 72 7d  -rpath,${pkgdir}
0b90: 2f 6c 69 62 22 0a 09 09 09 09 09 09 65 78 70 6f  /lib".......expo
0ba0: 72 74 20 4c 44 46 4c 41 47 53 0a 09 09 09 09 09  rt LDFLAGS......
0bb0: 09 3b 3b 0a 09 09 09 09 09 50 41 54 48 29 0a 09  .;;......PATH)..
0bc0: 09 09 09 09 09 50 41 54 48 3d 22 24 7b 50 41 54  .....PATH="${PAT
0bd0: 48 7d 3a 24 7b 70 6b 67 64 69 72 7d 2f 62 69 6e  H}:${pkgdir}/bin
0be0: 22 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 50  ".......export P
0bf0: 41 54 48 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09  ATH.......;;....
0c00: 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  ..PKG_CONFIG_PAT
0c10: 48 29 0a 09 09 09 09 09 09 69 66 20 5b 20 2d 64  H).......if [ -d
0c20: 20 22 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72   "${pkgconfigdir
0c30: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 09  }" ]; then......
0c40: 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  ..PKG_CONFIG_PAT
0c50: 48 3d 22 24 7b 50 4b 47 5f 43 4f 4e 46 49 47 5f  H="${PKG_CONFIG_
0c60: 50 41 54 48 7d 3a 24 7b 70 6b 67 63 6f 6e 66 69  PATH}:${pkgconfi
0c70: 67 64 69 72 7d 22 0a 09 09 09 09 09 09 09 65 78  gdir}"........ex
0c80: 70 6f 72 74 20 50 4b 47 5f 43 4f 4e 46 49 47 5f  port PKG_CONFIG_
0c90: 50 41 54 48 0a 09 09 09 09 09 09 66 69 0a 09 09  PATH.......fi...
0ca0: 09 09 09 09 3b 3b 0a 09 09 09 09 65 73 61 63 0a  ....;;.....esac.
0cb0: 09 09 09 64 6f 6e 65 0a 09 09 64 6f 6e 65 0a 0a  ...done...done..
0cc0: 09 09 69 66 20 5b 20 22 24 7b 70 6b 67 66 6f 75  ..if [ "${pkgfou
0cd0: 6e 64 7d 22 20 3d 20 27 30 27 20 5d 3b 20 74 68  nd}" = '0' ]; th
0ce0: 65 6e 0a 09 09 09 64 69 65 20 22 50 61 63 6b 61  en....die "Packa
0cf0: 67 65 20 24 7b 70 6b 67 7d 2f 24 7b 70 6b 67 76  ge ${pkg}/${pkgv
0d00: 65 72 73 69 6f 6e 3a 2d 2a 7d 40 24 7b 70 6b 67  ersion:-*}@${pkg
0d10: 64 6f 6d 61 69 6e 7d 20 6e 6f 74 20 66 6f 75 6e  domain} not foun
0d20: 64 2e 22 0a 09 09 66 69 0a 09 64 6f 6e 65 0a 7d  d."...fi..done.}
0d30: 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65 72 69 66  ..function verif
0d40: 79 50 72 65 72 65 71 75 69 73 69 74 65 73 28 29  yPrerequisites()
0d50: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0d60: 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63  n determineOsArc
0d70: 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28 75 6e 61  h() {..os="$(una
0d80: 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f 6e 76 3d  me -s | dd conv=
0d90: 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c  lcase 2>/dev/nul
0da0: 6c 29 22 0a 09 61 72 63 68 3d 22 24 28 75 6e 61  l)"..arch="$(una
0db0: 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f 6e 76 3d  me -m | dd conv=
0dc0: 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f 6e 75 6c  lcase 2>/dev/nul
0dd0: 6c 29 22 0a 0a 09 63 61 73 65 20 22 24 7b 61 72  l)"...case "${ar
0de0: 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38 36 29 0a  ch}" in...i?86).
0df0: 09 09 09 61 72 63 68 3d 27 69 78 38 36 27 0a 09  ...arch='ix86'..
0e00: 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a 0a 66 75  ..;;..esac.}..fu
0e10: 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65  nction determine
0e20: 50 72 65 66 69 78 28 29 20 7b 0a 09 64 65 74 65  Prefix() {..dete
0e30: 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a 09 70 72  rmineOsArch...pr
0e40: 65 66 69 78 73 75 66 66 69 78 3d 22 24 7b 70 6b  efixsuffix="${pk
0e50: 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d  g}/${os}-${arch}
0e60: 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 09 70 72  /${version}"..pr
0e70: 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70 70 66 73  efix="/opt/appfs
0e80: 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b 70 72 65  /${domain}/${pre
0e90: 66 69 78 73 75 66 66 69 78 7d 22 0a 09 64 65 73  fixsuffix}"..des
0ea0: 74 64 69 72 3d 22 24 28 70 77 64 29 2f 49 4e 53  tdir="$(pwd)/INS
0eb0: 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24 7b 64 65  T"...mkdir "${de
0ec0: 73 74 64 69 72 7d 22 20 7c 7c 20 64 69 65 0a 7d  stdir}" || die.}
0ed0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 63 6f  ..function preco
0ee0: 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 3a 0a 7d  nfigure() {..:.}
0ef0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 63  ..function postc
0f00: 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 3a 0a  onfigure() {..:.
0f10: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63 6f 6e 66  }..function conf
0f20: 69 67 75 72 65 5f 67 63 63 28 29 20 7b 0a 09 6c  igure_gcc() {..l
0f30: 6f 63 61 6c 20 67 6c 69 62 63 64 69 72 20 6c 69  ocal glibcdir li
0f40: 6e 75 78 68 65 61 64 65 72 73 64 69 72 0a 09 6c  nuxheadersdir..l
0f50: 6f 63 61 6c 20 64 79 6e 6c 69 6e 6b 65 72 0a 09  ocal dynlinker..
0f60: 6c 6f 63 61 6c 20 67 63 63 5f 64 65 66 61 75 6c  local gcc_defaul
0f70: 74 5f 68 65 61 64 65 72 73 0a 0a 09 67 6c 69 62  t_headers...glib
0f80: 63 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70 66 73  cdir="/opt/appfs
0f90: 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b 65 65  /core.appfs.rkee
0fa0: 6e 65 2e 6f 72 67 2f 67 6c 69 62 63 2f 70 6c 61  ne.org/glibc/pla
0fb0: 74 66 6f 72 6d 2f 6c 61 74 65 73 74 22 0a 09 67  tform/latest"..g
0fc0: 6c 69 62 63 64 69 72 3d 22 24 28 72 65 61 64 6c  libcdir="$(readl
0fd0: 69 6e 6b 20 2d 66 20 22 24 7b 67 6c 69 62 63 64  ink -f "${glibcd
0fe0: 69 72 7d 22 29 22 0a 0a 09 6c 69 6e 75 78 68 65  ir}")"...linuxhe
0ff0: 61 64 65 72 73 64 69 72 3d 22 2f 6f 70 74 2f 61  adersdir="/opt/a
1000: 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e  ppfs/core.appfs.
1010: 72 6b 65 65 6e 65 2e 6f 72 67 2f 6c 69 6e 75 78  rkeene.org/linux
1020: 2d 68 65 61 64 65 72 73 2f 70 6c 61 74 66 6f 72  -headers/platfor
1030: 6d 2f 6c 61 74 65 73 74 22 0a 09 6c 69 6e 75 78  m/latest"..linux
1040: 68 65 61 64 65 72 73 64 69 72 3d 22 24 28 72 65  headersdir="$(re
1050: 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b 6c 69 6e  adlink -f "${lin
1060: 75 78 68 65 61 64 65 72 73 64 69 72 7d 22 29 22  uxheadersdir}")"
1070: 0a 0a 09 64 79 6e 6c 69 6e 6b 65 72 3d 22 24 28  ...dynlinker="$(
1080: 6c 73 20 22 24 7b 67 6c 69 62 63 64 69 72 7d 22  ls "${glibcdir}"
1090: 2f 6c 69 62 2f 6c 64 2d 6c 69 6e 75 78 2a 2e 73  /lib/ld-linux*.s
10a0: 6f 2e 2a 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29  o.* | tail -n 1)
10b0: 22 0a 0a 09 69 66 20 5b 20 21 20 2d 66 20 22 24  "...if [ ! -f "$
10c0: 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 20 5d 3b 20  {dynlinker}" ]; 
10d0: 74 68 65 6e 0a 09 09 64 69 65 20 27 67 6c 69 62  then...die 'glib
10e0: 63 20 64 69 72 65 63 74 6f 72 79 20 69 73 20 6e  c directory is n
10f0: 6f 74 20 61 76 61 69 6c 61 62 6c 65 20 28 61 70  ot available (ap
1100: 70 66 73 20 72 75 6e 6e 69 6e 67 2f 77 6f 72 6b  pfs running/work
1110: 69 6e 67 3f 29 27 0a 09 66 69 0a 0a 09 67 63 63  ing?)'..fi...gcc
1120: 5f 64 65 66 61 75 6c 74 5f 68 65 61 64 65 72 73  _default_headers
1130: 3d 22 24 28 65 63 68 6f 20 27 27 20 7c 20 24 7b  ="$(echo '' | ${
1140: 43 50 50 3a 2d 63 70 70 7d 20 2d 76 20 32 3e 26  CPP:-cpp} -v 2>&
1150: 31 20 7c 20 73 65 64 20 27 2f 5e 45 6e 64 20 6f  1 | sed '/^End o
1160: 66 20 73 65 61 72 63 68 20 6c 69 73 74 2f 2c 24  f search list/,$
1170: 20 64 3b 30 2c 2f 73 65 61 72 63 68 20 73 74 61   d;0,/search sta
1180: 72 74 73 20 68 65 72 65 3a 24 2f 20 64 27 20 7c  rts here:$/ d' |
1190: 20 67 72 65 70 20 27 2f 67 63 63 2f 27 20 7c 20   grep '/gcc/' | 
11a0: 73 65 64 20 27 73 40 5e 20 2a 40 2d 49 40 27 20  sed 's@^ *@-I@' 
11b0: 7c 20 74 72 20 24 27 5c 6e 27 20 27 20 27 29 22  | tr $'\n' ' ')"
11c0: 0a 0a 09 43 43 3d 22 24 7b 43 43 3a 2d 67 63 63  ...CC="${CC:-gcc
11d0: 7d 20 2d 6e 6f 73 74 64 69 6e 63 20 24 7b 67 63  } -nostdinc ${gc
11e0: 63 5f 64 65 66 61 75 6c 74 5f 68 65 61 64 65 72  c_default_header
11f0: 73 7d 20 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d  s} -I${glibcdir}
1200: 2f 69 6e 63 6c 75 64 65 22 0a 0a 09 69 66 20 21  /include"...if !
1210: 20 65 63 68 6f 20 22 20 24 7b 72 65 71 75 69 72   echo " ${requir
1220: 65 5b 2a 5d 7d 20 22 20 7c 20 67 72 65 70 20 27  e[*]} " | grep '
1230: 20 6c 69 6e 75 78 2d 68 65 61 64 65 72 73 5b 2f   linux-headers[/
1240: 40 3a 20 5d 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  @: ]' >/dev/null
1250: 3b 20 74 68 65 6e 0a 09 09 43 43 3d 22 24 7b 43  ; then...CC="${C
1260: 43 7d 20 2d 49 24 7b 6c 69 6e 75 78 68 65 61 64  C} -I${linuxhead
1270: 65 72 73 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  ersdir}/include"
1280: 0a 09 66 69 0a 0a 09 42 55 49 4c 44 5f 43 43 3d  ..fi...BUILD_CC=
1290: 22 24 7b 43 43 7d 22 0a 09 48 4f 53 54 5f 43 43  "${CC}"..HOST_CC
12a0: 3d 22 24 7b 43 43 7d 22 0a 09 4c 44 46 4c 41 47  ="${CC}"..LDFLAG
12b0: 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d 4c  S="${LDFLAGS} -L
12c0: 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20  ${glibcdir}/lib 
12d0: 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c 24 7b 67 6c  -Wl,--rpath,${gl
12e0: 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c  ibcdir}/lib -Wl,
12f0: 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65 72  --dynamic-linker
1300: 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a 09  ,${dynlinker}"..
1310: 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42 44 49  PKG_CONFIG_LIBDI
1320: 52 3d 22 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c  R="${glibcdir}/l
1330: 69 62 2f 70 6b 67 63 6f 6e 66 69 67 22 0a 09 65  ib/pkgconfig"..e
1340: 78 70 6f 72 74 20 43 43 20 42 55 49 4c 44 5f 43  xport CC BUILD_C
1350: 43 20 48 4f 53 54 5f 43 43 20 4c 44 46 4c 41 47  C HOST_CC LDFLAG
1360: 53 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49 42  S PKG_CONFIG_LIB
1370: 44 49 52 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  DIR.}..function 
1380: 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09 63  configure() {..c
1390: 6f 6e 66 69 67 75 72 65 5f 67 63 63 0a 09 2e 2f  onfigure_gcc.../
13a0: 63 6f 6e 66 69 67 75 72 65 20 2d 2d 70 72 65 66  configure --pref
13b0: 69 78 3d 22 24 7b 70 72 65 66 69 78 7d 22 20 2d  ix="${prefix}" -
13c0: 2d 73 79 73 63 6f 6e 66 64 69 72 3d 22 24 7b 70  -sysconfdir="${p
13d0: 72 65 66 69 78 7d 2f 65 74 63 22 20 2d 2d 6c 69  refix}/etc" --li
13e0: 62 64 69 72 3d 22 24 7b 70 72 65 66 69 78 7d 2f  bdir="${prefix}/
13f0: 6c 69 62 22 20 2d 2d 6c 6f 63 61 6c 73 74 61 74  lib" --localstat
1400: 65 64 69 72 3d 2f 76 61 72 20 22 24 7b 63 6f 6e  edir=/var "${con
1410: 66 69 67 75 72 65 5f 65 78 74 72 61 5b 40 5d 7d  figure_extra[@]}
1420: 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  ".}..function pr
1430: 65 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a  ebuild() {..:.}.
1440: 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75  .function postbu
1450: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
1460: 6e 63 74 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b  nction build() {
1470: 0a 09 67 72 65 70 20 22 44 45 53 54 44 49 52 22  ..grep "DESTDIR"
1480: 20 4d 61 6b 65 66 69 6c 65 20 3e 2f 64 65 76 2f   Makefile >/dev/
1490: 6e 75 6c 6c 20 7c 7c 20 64 69 65 20 22 44 6f 6e  null || die "Don
14a0: 27 74 20 6b 6e 6f 77 20 68 6f 77 20 74 6f 20 62  't know how to b
14b0: 75 69 6c 64 20 74 68 69 73 20 73 6f 66 74 77 61  uild this softwa
14c0: 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a 66 75  re"...make.}..fu
14d0: 6e 63 74 69 6f 6e 20 70 72 65 69 6e 73 74 61 6c  nction preinstal
14e0: 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  l() {..:.}..func
14f0: 74 69 6f 6e 20 70 6f 73 74 69 6e 73 74 61 6c 6c  tion postinstall
1500: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
1510: 69 6f 6e 20 69 6e 73 74 61 6c 6c 28 29 20 7b 0a  ion install() {.
1520: 09 6d 61 6b 65 20 69 6e 73 74 61 6c 6c 20 44 45  .make install DE
1530: 53 54 44 49 52 3d 22 24 7b 64 65 73 74 64 69 72  STDIR="${destdir
1540: 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63  }".}..function c
1550: 6c 65 61 6e 75 70 28 29 20 7b 0a 09 63 64 20 22  leanup() {..cd "
1560: 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65  ${workdir}" || e
1570: 78 69 74 20 31 0a 09 63 64 20 2e 2e 20 7c 7c 20  xit 1..cd .. || 
1580: 65 78 69 74 20 31 0a 09 72 6d 20 2d 72 66 20 22  exit 1..rm -rf "
1590: 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a 0a 66  ${workdir}".}..f
15a0: 75 6e 63 74 69 6f 6e 20 64 69 65 28 29 20 7b 0a  unction die() {.
15b0: 09 6c 6f 63 61 6c 20 6d 65 73 73 61 67 65 0a 0a  .local message..
15c0: 09 6d 65 73 73 61 67 65 3d 22 24 31 22 0a 0a 09  .message="$1"...
15d0: 69 66 20 5b 20 2d 6e 20 22 24 7b 6d 65 73 73 61  if [ -n "${messa
15e0: 67 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65  ge}" ]; then...e
15f0: 63 68 6f 20 22 65 72 72 6f 72 3a 20 24 7b 6d 65  cho "error: ${me
1600: 73 73 61 67 65 7d 22 20 3e 26 32 0a 09 66 69 0a  ssage}" >&2..fi.
1610: 0a 09 65 78 69 74 20 31 0a 7d 0a 0a 73 63 72 69  ..exit 1.}..scri
1620: 70 74 64 69 72 3d 22 24 28 63 64 20 22 24 28 64  ptdir="$(cd "$(d
1630: 69 72 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20  irname "$(which 
1640: 22 24 30 22 29 22 29 22 20 26 26 20 70 77 64 29  "$0")")" && pwd)
1650: 22 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 73 63 72  ".if [ -z "${scr
1660: 69 70 74 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e  iptdir}" ]; then
1670: 0a 09 65 63 68 6f 20 22 55 6e 61 62 6c 65 20 74  ..echo "Unable t
1680: 6f 20 6c 6f 63 61 74 65 20 73 63 72 69 70 74 20  o locate script 
1690: 64 69 72 65 63 74 6f 72 79 22 20 3e 26 32 0a 0a  directory" >&2..
16a0: 09 65 78 69 74 20 31 0a 66 69 0a 0a 63 64 20 22  .exit 1.fi..cd "
16b0: 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20 7c 7c  ${scriptdir}" ||
16c0: 20 65 78 69 74 20 31 0a 0a 69 66 20 5b 20 2d 66   exit 1..if [ -f
16d0: 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27 20 5d 3b   'build.conf' ];
16e0: 20 74 68 65 6e 0a 09 2e 20 27 62 75 69 6c 64 2e   then... 'build.
16f0: 63 6f 6e 66 27 0a 66 69 0a 0a 69 66 20 5b 20 2d  conf'.fi..if [ -
1700: 64 20 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 20  d "pkgs/${pkg}" 
1710: 5d 3b 20 74 68 65 6e 0a 09 70 6b 67 64 69 72 3d  ]; then..pkgdir=
1720: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70  "pkgs/${pkg}"..p
1730: 6b 67 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69 72  kgfile="${pkgdir
1740: 7d 2f 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70 6b  }/info".else..pk
1750: 67 66 69 6c 65 3d 22 70 6b 67 73 2f 24 7b 70 6b  gfile="pkgs/${pk
1760: 67 7d 22 0a 09 70 6b 67 64 69 72 3d 22 24 7b 70  g}"..pkgdir="${p
1770: 6b 67 66 69 6c 65 7d 22 0a 66 69 0a 0a 69 66 20  kgfile}".fi..if 
1780: 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67 66 69 6c  [ ! -e "${pkgfil
1790: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68  e}" ]; then..ech
17a0: 6f 20 22 49 6e 76 61 6c 69 64 20 70 61 63 6b 61  o "Invalid packa
17b0: 67 65 2e 22 20 3e 26 32 0a 0a 09 65 78 69 74 20  ge." >&2...exit 
17c0: 31 0a 66 69 0a 0a 70 6b 67 64 61 74 65 3d 22 24  1.fi..pkgdate="$
17d0: 28 66 6f 72 20 61 72 74 69 66 61 63 74 20 69 6e  (for artifact in
17e0: 20 24 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69   $(find "${pkgdi
17f0: 72 7d 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69  r}" -type f -pri
1800: 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 6e 20 31  nt0 | xargs -n 1
1810: 20 2d 30 20 66 6f 73 73 69 6c 20 66 69 6e 66 6f   -0 fossil finfo
1820: 20 2d 2d 6c 69 6d 69 74 20 31 20 2d 2d 77 69 64   --limit 1 --wid
1830: 74 68 20 30 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  th 0 2>/dev/null
1840: 20 7c 20 67 72 65 70 20 27 5e 5b 30 2d 39 5d 5b   | grep '^[0-9][
1850: 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b  0-9][0-9][0-9]-[
1860: 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b  0-9][0-9]-[0-9][
1870: 30 2d 39 5d 20 27 20 7c 20 73 65 64 20 27 73 40  0-9] ' | sed 's@
1880: 5e 5b 5e 20 5d 2a 20 5c 5b 40 40 3b 73 40 5c 5d  ^[^ ]* \[@@;s@\]
1890: 2e 2a 40 40 27 20 7c 20 73 6f 72 74 20 2d 75 29  .*@@' | sort -u)
18a0: 3b 20 64 6f 20 66 6f 73 73 69 6c 20 69 6e 66 6f  ; do fossil info
18b0: 20 22 24 7b 61 72 74 69 66 61 63 74 7d 22 20 7c   "${artifact}" |
18c0: 20 61 77 6b 20 27 2f 5e 75 75 69 64 3a 2f 7b 20   awk '/^uuid:/{ 
18d0: 70 72 69 6e 74 20 24 33 20 24 34 20 7d 27 20 7c  print $3 $4 }' |
18e0: 20 73 65 64 20 27 73 40 5b 2d 3a 5d 40 40 67 3b   sed 's@[-:]@@g;
18f0: 73 40 2e 2e 24 40 5c 2e 26 40 27 3b 20 64 6f 6e  s@..$@\.&@'; don
1900: 65 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61  e | sort -n | ta
1910: 69 6c 20 2d 6e 20 31 29 22 0a 69 66 20 5b 20 2d  il -n 1)".if [ -
1920: 7a 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 5d  z "${pkgdate}" ]
1930: 3b 20 74 68 65 6e 0a 09 70 6b 67 64 61 74 65 3d  ; then..pkgdate=
1940: 22 24 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69  "$(find "${pkgdi
1950: 72 7d 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69  r}" -type f -pri
1960: 6e 74 66 20 27 25 54 59 25 54 6d 25 54 64 25 54  ntf '%TY%Tm%Td%T
1970: 48 25 54 4d 2e 25 54 53 5c 6e 27 20 32 3e 2f 64  H%TM.%TS\n' 2>/d
1980: 65 76 2f 6e 75 6c 6c 20 7c 20 63 75 74 20 2d 66  ev/null | cut -f
1990: 20 31 2d 32 20 2d 64 20 27 2e 27 20 7c 20 73 6f   1-2 -d '.' | so
19a0: 72 74 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20  rt -n | tail -n 
19b0: 31 29 22 0a 66 69 0a 0a 2e 20 22 24 7b 70 6b 67  1)".fi... "${pkg
19c0: 66 69 6c 65 7d 22 0a 0a 61 72 63 68 69 76 65 64  file}"..archived
19d0: 69 72 3d 22 24 28 70 77 64 29 2f 41 52 43 48 49  ir="$(pwd)/ARCHI
19e0: 56 45 22 0a 77 6f 72 6b 64 69 72 3d 22 77 6f 72  VE".workdir="wor
19f0: 6b 64 69 72 2d 24 24 24 7b 52 41 4e 44 4f 4d 7d  kdir-$$${RANDOM}
1a00: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
1a10: 4d 7d 22 0a 70 6b 67 61 72 63 68 69 76 65 3d 22  M}".pkgarchive="
1a20: 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f 24 7b  ${archivedir}/${
1a30: 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 22  pkg}-${version}"
1a40: 0a 6d 6b 64 69 72 20 22 24 7b 61 72 63 68 69 76  .mkdir "${archiv
1a50: 65 64 69 72 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c  edir}" >/dev/nul
1a60: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d 6b  l 2>/dev/null.mk
1a70: 64 69 72 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  dir "${workdir}"
1a80: 20 7c 7c 20 65 78 69 74 20 31 0a 63 64 20 22 24   || exit 1.cd "$
1a90: 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78  {workdir}" || ex
1aa0: 69 74 20 31 0a 77 6f 72 6b 64 69 72 3d 22 24 28  it 1.workdir="$(
1ab0: 70 77 64 29 22 0a 0a 23 20 44 6f 77 6e 6c 6f 61  pwd)"..# Downloa
1ac0: 64 0a 64 6f 77 6e 6c 6f 61 64 0a 0a 23 20 45 78  d.download..# Ex
1ad0: 74 72 61 63 74 0a 65 78 74 72 61 63 74 0a 0a 23  tract.extract..#
1ae0: 20 49 66 20 77 65 20 6a 75 73 74 20 68 61 76 65   If we just have
1af0: 20 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c 20   one directory, 
1b00: 75 73 65 20 74 68 61 74 20 64 69 72 65 63 74 6f  use that directo
1b10: 72 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20 2a  ry.dir="$(echo *
1b20: 29 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64 69  )".if [ -e "${di
1b30: 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76 20  r}" ]; then..mv 
1b40: 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69 0a  "${dir}"/* ..fi.
1b50: 0a 23 20 56 65 72 69 66 79 20 70 72 65 2d 72 65  .# Verify pre-re
1b60: 71 75 69 73 69 74 65 73 20 61 72 65 20 6d 65 74  quisites are met
1b70: 0a 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50  .verifyRequiredP
1b80: 61 63 6b 61 67 65 73 20 7c 7c 20 64 69 65 20 27  ackages || die '
1b90: 52 65 71 75 69 72 65 64 20 70 61 63 6b 61 67 65  Required package
1ba0: 73 20 6d 69 73 73 69 6e 67 27 0a 76 65 72 69 66  s missing'.verif
1bb0: 79 50 72 65 72 65 71 75 69 73 69 74 65 73 20 7c  yPrerequisites |
1bc0: 7c 20 64 69 65 20 27 50 72 65 72 65 71 75 69 73  | die 'Prerequis
1bd0: 69 74 69 65 73 20 66 61 69 6c 65 64 27 0a 0a 23  ities failed'..#
1be0: 20 53 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a 73   Start logging.s
1bf0: 65 74 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d 69  et -x..# Determi
1c00: 6e 65 20 70 72 6f 70 65 72 74 69 65 73 0a 64 65  ne properties.de
1c10: 74 65 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a 23  terminePrefix..#
1c20: 20 53 74 61 72 74 20 74 68 65 20 62 75 69 6c 64   Start the build
1c30: 0a 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c 7c  .preconfigure ||
1c40: 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67 75   die 'preconfigu
1c50: 72 65 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66 69  re failed'.confi
1c60: 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63 6f 6e  gure || die 'con
1c70: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 70  figure failed'.p
1c80: 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20  ostconfigure || 
1c90: 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67 75  die 'postconfigu
1ca0: 72 65 20 66 61 69 6c 65 64 27 0a 0a 70 72 65 62  re failed'..preb
1cb0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65  uild || die 'pre
1cc0: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 62 75  build failed'.bu
1cd0: 69 6c 64 20 7c 7c 20 64 69 65 20 27 62 75 69 6c  ild || die 'buil
1ce0: 64 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 62 75  d failed'.postbu
1cf0: 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73 74  ild || die 'post
1d00: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a 70  build failed'..p
1d10: 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65  reinstall || die
1d20: 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61 69   'preinstall fai
1d30: 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c 20  led'.install || 
1d40: 64 69 65 20 27 69 6e 73 74 61 6c 6c 20 66 61 69  die 'install fai
1d50: 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c 6c  led'.postinstall
1d60: 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e 73   || die 'postins
1d70: 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28 0a  tall failed'..(.
1d80: 09 63 61 73 65 20 22 24 7b 74 61 72 67 65 74 6d  .case "${targetm
1d90: 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e 73 74 61  ode}" in...insta
1da0: 6c 6c 29 0a 09 09 09 61 70 70 64 69 72 3d 22 24  ll)....appdir="$
1db0: 28 61 70 70 66 73 69 6e 73 74 61 6c 6c 64 69 72  (appfsinstalldir
1dc0: 29 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69 78  )/${prefixsuffix
1dd0: 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d 70 20 22  }"....mkdir -p "
1de0: 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09 09 09 63  ${appdir}".....c
1df0: 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b  d "${destdir}/${
1e00: 70 72 65 66 69 78 7d 22 20 7c 7c 20 65 78 69 74  prefix}" || exit
1e10: 20 31 0a 0a 09 09 09 63 70 20 2d 72 70 20 2a 20   1.....cp -rp * 
1e20: 22 24 7b 61 70 70 64 69 72 7d 22 0a 09 09 09 66  "${appdir}"....f
1e30: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
1e40: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1e50: 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24 7b 70  -0 touch -t "${p
1e60: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
1e70: 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72   "${appdir}" -pr
1e80: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
1e90: 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70  touch -m -t "${p
1ea0: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
1eb0: 20 22 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72   "${appdir}" -pr
1ec0: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
1ed0: 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24 7b 70  touch -a -t "${p
1ee0: 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b 3b 0a 09  kgdate}"....;;..
1ef0: 09 61 72 63 68 69 76 65 29 0a 09 09 09 61 72 63  .archive)....arc
1f00: 68 69 76 65 66 69 6c 65 3d 22 24 7b 73 63 72 69  hivefile="${scri
1f10: 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d 2d 24 7b  ptdir}/${pkg}-${
1f20: 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63 68 6f 20  version}-$(echo 
1f30: 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 7c 20 73  "${pkgdate}" | s
1f40: 65 64 20 27 73 40 5c 2e 40 40 67 27 29 2d 24 7b  ed 's@\.@@g')-${
1f50: 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d 24 7b 64 6f  os}-${arch}-${do
1f60: 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09 09 09 63  main}.cpio"....c
1f70: 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b  d "${destdir}/${
1f80: 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e 2f 2e 2e  prefix}/../../..
1f90: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 66  " || exit 1....f
1fa0: 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75 66  ind "${prefixsuf
1fb0: 66 69 78 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20  fix}" -print0 | 
1fc0: 78 61 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d  xargs -0 touch -
1fd0: 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09  t "${pkgdate}"..
1fe0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
1ff0: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
2000: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
2010: 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b 67 64 61  h -m -t "${pkgda
2020: 74 65 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b  te}"....find "${
2030: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d  prefixsuffix}" -
2040: 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d  print0 | xargs -
2050: 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22 24  0 touch -a -t "$
2060: 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69  {pkgdate}"....fi
2070: 6e 64 20 22 24 7b 70 72 65 66 69 78 73 75 66 66  nd "${prefixsuff
2080: 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c 20 63 70  ix}" | sort | cp
2090: 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a 30 20 2d  io --owner 0:0 -
20a0: 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22 24 7b 61  H newc -o > "${a
20b0: 72 63 68 69 76 65 66 69 6c 65 7d 22 0a 09 09 09  rchivefile}"....
20c0: 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c 20 64 69  ;;..esac.) || di
20d0: 65 20 27 66 69 6e 61 6c 20 69 6e 73 74 61 6c 6c  e 'final install
20e0: 61 74 69 6f 6e 20 66 61 69 6c 65 64 27 0a 0a 63  ation failed'..c
20f0: 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20 30 0a     leanup..exit 0.